function [im] = tonemap_gamma(hdr, gamma)

% convert to hsv colorspace (hue - saturation - value) 
hsv = rgb2hsv(hdr); 

% 3rd dimension corresponds to value (similar to intensity in
% grayscale image)
intensity = hsv(:,:,3); 

% make logarithmic transformation, taking care of the zero problem
log_i = log(intensity + 1); 

% === BEGIN compute output log intensity

out_log_i = gamma*log_i; 

% === END compute output log intensity 


% convert back to intensity 
out_i = exp(out_log_i) - 1; 

% convert back to rgb 
hsv(:,:,3) = out_i; 
im = hsv2rgb(hsv); 

