function [im, f] = tonemap_histeq(hdr)

% convert to hsv colorspace (hue - saturation - value) 
hsv = rgb2hsv(hdr); 

% 3rd dimension corresponds to value (similar to intensity in
% grayscale image)
intensity = hsv(:,:,3); 

% make logarithmic transformation, taking care of the zero problem
log_i = log(intensity + 1); 

% === BEGIN compute output log intensity

% equalization 
binN = 6000; 

log_i = log_i - min(log_i(:)); 
log_i = log_i / max(log_i(:)); 

hstep = 1/(binN-1); 
h = hist(log_i(:), 0:hstep:1+hstep*0.5); 

f = cumsum(h); f = mean([0, f(1:end-1); f(1:end)]);
f = f/f(end); 

out_log_i = f(floor(log_i/hstep)+1); 

% === END compute output log intensity 


% convert back to intensity 
out_i = exp(out_log_i)-1; 

% convert back to rgb 
hsv(:,:,3) = out_i; 
im = hsv2rgb(hsv); 
