function [im] = tonemap_log(hdr)

% convert to hsv colorspace (hue - saturation - value) 
hsv = rgb2hsv(hdr); 

% 3rd dimension corresponds to value (similar to intensity in
% grayscale image)
intensity = hsv(:,:,3); 

% make logarithmic transformation, taking care of the zero problem
log_i = log(intensity + 1); 

out_i = log_i; 

% convert back to rgb 
hsv(:,:,3) = out_i; 
im = hsv2rgb(hsv); 
